diff --git a/gcc/analyzer/constraint-manager.h b/gcc/analyzer/constraint-manager.h
index 0f4506cc40d..e65ad827ce2 100644
--- a/gcc/analyzer/constraint-manager.h
+++ b/gcc/analyzer/constraint-manager.h
@@ -23,228 +23,6 @@ along with GCC; see the file COPYING3.  If not see
 
 namespace ana {
 
-class constraint_manager;
-
-/* Abstract base class for specifying how state should be purged.  */
-
-class purge_criteria
-{
-public:
-  virtual ~purge_criteria () {}
-  virtual bool should_purge_p (svalue_id sid) const = 0;
-};
-
-/* An equivalence class within a constraint manager: a set of
-   svalue_ids that are known to all be equal to each other,
-   together with an optional tree constant that they are equal to.  */
-
-class equiv_class
-{
-public:
-  equiv_class ();
-  equiv_class (const equiv_class &other);
-
-  hashval_t hash () const;
-  bool operator== (const equiv_class &other);
-
-  void add (svalue_id sid, const constraint_manager &cm);
-  bool del (svalue_id sid);
-
-  tree get_any_constant () const { return m_constant; }
-
-  svalue_id get_representative () const;
-
-  void remap_svalue_ids (const svalue_id_map &map);
-
-  void canonicalize ();
-
-  void print (pretty_printer *pp) const;
-
-  /* An equivalence class can contain multiple constants (e.g. multiple
-     different zeroes, for different types); these are just for the last
-     constant added.  */
-  tree m_constant;
-  svalue_id m_cst_sid;
-
-  // TODO: should this be a set rather than a vec?
-  auto_vec<svalue_id> m_vars;
-};
-
-/* The various kinds of constraint.  */
-
-enum constraint_op
-{
-  CONSTRAINT_NE,
-  CONSTRAINT_LT,
-  CONSTRAINT_LE
-};
-
-const char *constraint_op_code (enum constraint_op c_op);
-
-/* An ID for an equiv_class within a constraint_manager.  Internally, this
-   is an index into a vector of equiv_class * within the constraint_manager.  */
-
-class equiv_class_id
-{
-public:
-  static equiv_class_id null () { return equiv_class_id (-1); }
-
-  equiv_class_id (unsigned idx) : m_idx (idx) {}
-  const equiv_class &get_obj (const constraint_manager &cm) const;
-  equiv_class &get_obj (constraint_manager &cm) const;
-
-  bool operator== (const equiv_class_id &other) const
-  {
-    return m_idx == other.m_idx;
-  }
-  bool operator!= (const equiv_class_id &other) const
-  {
-    return m_idx != other.m_idx;
-  }
-
-  bool null_p () const { return m_idx == -1; }
-
-  static equiv_class_id from_int (int idx) { return equiv_class_id (idx); }
-  int as_int () const { return m_idx; }
-
-  void print (pretty_printer *pp) const;
-
-  void update_for_removal (equiv_class_id other)
-  {
-    if (m_idx > other.m_idx)
-      m_idx--;
-  }
-
-  int m_idx;
-};
-
-/* A relationship between two equivalence classes in a constraint_manager.  */
-
-class constraint
-{
- public:
-  constraint (equiv_class_id lhs, enum constraint_op c_op, equiv_class_id rhs)
-  : m_lhs (lhs), m_op (c_op), m_rhs (rhs)
-  {
-    gcc_assert (!lhs.null_p ());
-    gcc_assert (!rhs.null_p ());
-  }
-
-  void print (pretty_printer *pp, const constraint_manager &cm) const;
-
-  hashval_t hash () const;
-  bool operator== (const constraint &other) const;
-
-  /* Is this an ordering, rather than a "!=".  */
-  bool is_ordering_p () const
-  {
-    return m_op != CONSTRAINT_NE;
-  }
-
-  equiv_class_id m_lhs;
-  enum constraint_op m_op;
-  equiv_class_id m_rhs;
-};
-
-/* An abstract base class for use with constraint_manager::for_each_fact.  */
-
-class fact_visitor
-{
- public:
-  virtual ~fact_visitor () {}
-  virtual void on_fact (svalue_id lhs, enum tree_code, svalue_id rhs) = 0;
-};
-
-/* A collection of equivalence classes and constraints on them.
-
-   Given N svalues, this can be thought of as representing a subset of
-   N-dimensional space.  When we call add_constraint,
-   we are effectively taking an intersection with that constraint.  */
-
-class constraint_manager
-{
-public:
-  constraint_manager () {}
-  constraint_manager (const constraint_manager &other);
-  virtual ~constraint_manager () {}
-
-  virtual constraint_manager *clone (region_model *) const = 0;
-  virtual tree maybe_get_constant (svalue_id sid) const = 0;
-  virtual svalue_id get_sid_for_constant (tree cst) const = 0;
-  virtual int get_num_svalues () const = 0;
-
-  constraint_manager& operator= (const constraint_manager &other);
-
-  hashval_t hash () const;
-  bool operator== (const constraint_manager &other) const;
-  bool operator!= (const constraint_manager &other) const
-  {
-    return !(*this == other);
-  }
-
-  void print (pretty_printer *pp) const;
-  void dump_to_pp (pretty_printer *pp) const;
-  void dump (FILE *fp) const;
-  void dump () const;
-
-  const equiv_class &get_equiv_class_by_index (unsigned idx) const
-  {
-    return *m_equiv_classes[idx];
-  }
-  equiv_class &get_equiv_class_by_index (unsigned idx)
-  {
-    return *m_equiv_classes[idx];
-  }
-
-  equiv_class &get_equiv_class (svalue_id sid)
-  {
-    equiv_class_id ec_id = get_or_add_equiv_class (sid);
-    return ec_id.get_obj (*this);
-  }
-
-  bool add_constraint (svalue_id lhs, enum tree_code op, svalue_id rhs);
-
-  bool add_constraint (equiv_class_id lhs_ec_id,
-		       enum tree_code op,
-		       equiv_class_id rhs_ec_id);
-
-  bool get_equiv_class_by_sid (svalue_id sid, equiv_class_id *out) const;
-  equiv_class_id get_or_add_equiv_class (svalue_id sid);
-  tristate eval_condition (equiv_class_id lhs,
-			   enum tree_code op,
-			   equiv_class_id rhs);
-  tristate eval_condition (svalue_id lhs,
-			   enum tree_code op,
-			   svalue_id rhs);
-
-  void purge (const purge_criteria &p, purge_stats *stats);
-
-  void remap_svalue_ids (const svalue_id_map &map);
-
-  void canonicalize (unsigned num_svalue_ids);
-
-  static void merge (const constraint_manager &cm_a,
-		     const constraint_manager &cm_b,
-		     constraint_manager *out,
-		     const model_merger &merger);
-
-  void for_each_fact (fact_visitor *) const;
-
-  void validate () const;
-
-  auto_delete_vec<equiv_class> m_equiv_classes;
-  auto_vec<constraint> m_constraints;
-
- private:
-  static void clean_merger_input (const constraint_manager &cm_in,
-				  const one_way_svalue_id_map &map_sid_to_m,
-				  constraint_manager *out);
-
-  void add_constraint_internal (equiv_class_id lhs_id,
-				enum constraint_op c_op,
-				equiv_class_id rhs_id);
-};
-
 } // namespace ana
 
 #endif /* GCC_ANALYZER_CONSTRAINT_MANAGER_H */
diff --git a/gcc/analyzer/diagnostic-manager.cc b/gcc/analyzer/diagnostic-manager.cc
index f7c63080caf..a0e1ddb45b1 100644
--- a/gcc/analyzer/diagnostic-manager.cc
+++ b/gcc/analyzer/diagnostic-manager.cc
@@ -379,10 +379,7 @@ public:
 
     feasibility_problem *p = NULL;
     bool feasible;
-    if (m_engine2)
-      feasible = dc->get_path ().feasible2_p (logger, &p, m_engine2, eg);
-    else
-      feasible = dc->get_path ().feasible_p (logger, &p);
+    feasible = dc->get_path ().feasible2_p (logger, &p, m_engine2, eg);
     if (!feasible)
       {
 	if (logger)
@@ -609,12 +606,15 @@ get_any_origin (const gimple *stmt,
 
   gcc_assert (dst_rep);
 
+#if 0
   // TODO:
   if (dst_state.m_region_model == NULL)
     return NULL;
+#endif
 
   if (const gassign *assign = dyn_cast <const gassign *> (stmt))
     {
+#if 0
       tree lhs = gimple_assign_lhs (assign);
       /* Use region IDs to compare lhs with DST_REP, bulletproofing against
 	 cases where they can't have lvalues by using
@@ -637,6 +637,7 @@ get_any_origin (const gimple *stmt,
 	      return rhs1;
 	    }
 	}
+#endif
     }
   return NULL_TREE;
 }
@@ -667,178 +668,6 @@ diagnostic_manager::build_emission_path (const path_builder &pb,
     }
 }
 
-/* Subclass of state_change_visitor that creates state_change_event
-   instances.  */
-
-class state_change_event_creator : public state_change_visitor
-{
-public:
-  state_change_event_creator (const exploded_edge &eedge,
-			      checker_path *emission_path)
-    : m_eedge (eedge),
-      m_emission_path (emission_path)
-  {}
-
-  bool on_global_state_change (const state_machine &sm,
-			       state_machine::state_t src_sm_val,
-			       state_machine::state_t dst_sm_val)
-    FINAL OVERRIDE
-  {
-    const exploded_node *src_node = m_eedge.m_src;
-    const program_point &src_point = src_node->get_point ();
-    const int src_stack_depth = src_point.get_stack_depth ();
-    const exploded_node *dst_node = m_eedge.m_dest;
-    const gimple *stmt = src_point.get_stmt ();
-    const supernode *supernode = src_point.get_supernode ();
-    const program_state &dst_state = dst_node->get_state ();
-
-    int stack_depth = src_stack_depth;
-
-    m_emission_path->add_event (new state_change_event (supernode,
-							stmt,
-							stack_depth,
-							sm,
-							NULL_TREE,
-							src_sm_val,
-							dst_sm_val,
-							NULL_TREE,
-							dst_state));
-    return false;
-  }
-
-  bool on_state_change (const state_machine &sm,
-			state_machine::state_t src_sm_val,
-			state_machine::state_t dst_sm_val,
-			tree dst_rep,
-			svalue_id dst_origin_sid) FINAL OVERRIDE
-  {
-    const exploded_node *src_node = m_eedge.m_src;
-    const program_point &src_point = src_node->get_point ();
-    const int src_stack_depth = src_point.get_stack_depth ();
-    const exploded_node *dst_node = m_eedge.m_dest;
-    const gimple *stmt = src_point.get_stmt ();
-    const supernode *supernode = src_point.get_supernode ();
-    const program_state &dst_state = dst_node->get_state ();
-
-    int stack_depth = src_stack_depth;
-
-    if (m_eedge.m_sedge
-	&& m_eedge.m_sedge->m_kind == SUPEREDGE_CFG_EDGE)
-      {
-	supernode = src_point.get_supernode ();
-	stmt = supernode->get_last_stmt ();
-	stack_depth = src_stack_depth;
-      }
-
-    /* Bulletproofing for state changes at calls/returns;
-       TODO: is there a better way? */
-    if (!stmt)
-      return false;
-
-    tree origin_rep
-      = dst_state.get_representative_tree (dst_origin_sid);
-
-    if (origin_rep == NULL_TREE)
-      origin_rep = get_any_origin (stmt, dst_rep, dst_state);
-    m_emission_path->add_event (new state_change_event (supernode,
-							stmt,
-							stack_depth,
-							sm,
-							dst_rep,
-							src_sm_val,
-							dst_sm_val,
-							origin_rep,
-							dst_state));
-    return false;
-  }
-
-  const exploded_edge &m_eedge;
-  checker_path *m_emission_path;
-};
-
-/* Compare SRC_STATE and DST_STATE (which use EXT_STATE), and call
-   VISITOR's on_state_change for every sm-state change that occurs
-   to a tree, and on_global_state_change for every global state change
-   that occurs.
-
-   This determines the state changes that ought to be reported to
-   the user: a combination of the effects of changes to sm_state_map
-   (which maps svalues to sm-states), and of region_model changes
-   (which map trees to svalues).
-
-   Bail out early and return true if any call to on_global_state_change
-   or on_state_change returns true, otherwise return false.
-
-   This is split out to make it easier to experiment with changes to
-   exploded_node granularity (so that we can observe what state changes
-   lead to state_change_events being emitted).  */
-
-bool
-for_each_state_change (const program_state &src_state,
-		       const program_state &dst_state,
-		       const extrinsic_state &ext_state,
-		       state_change_visitor *visitor)
-{
-  gcc_assert (src_state.m_checker_states.length ()
-	      == ext_state.get_num_checkers ());
-  gcc_assert (dst_state.m_checker_states.length ()
-	      == ext_state.get_num_checkers ());
-  for (unsigned i = 0; i < ext_state.get_num_checkers (); i++)
-    {
-      const state_machine &sm = ext_state.get_sm (i);
-      const sm_state_map &src_smap = *src_state.m_checker_states[i];
-      const sm_state_map &dst_smap = *dst_state.m_checker_states[i];
-
-      /* Add events for any global state changes.  */
-      if (src_smap.get_global_state () != dst_smap.get_global_state ())
-	if (visitor->on_global_state_change (sm,
-					     src_smap.get_global_state (),
-					     dst_smap.get_global_state ()))
-	  return true;
-
-      /* Add events for per-svalue state changes.  */
-      for (sm_state_map::iterator_t iter = dst_smap.begin ();
-	   iter != dst_smap.end ();
-	   ++iter)
-	{
-	  /* Ideally we'd directly compare the SM state between src state
-	     and dst state, but there's no guarantee that the IDs can
-	     be meaningfully compared.  */
-	  svalue_id dst_sid = (*iter).first;
-	  state_machine::state_t dst_sm_val = (*iter).second.m_state;
-
-	  auto_vec<path_var> dst_pvs;
-	  dst_state.m_region_model->get_path_vars_for_svalue (dst_sid,
-							      &dst_pvs);
-
-	  unsigned j;
-	  path_var *dst_pv;
-	  FOR_EACH_VEC_ELT (dst_pvs, j, dst_pv)
-	    {
-	      tree dst_rep = dst_pv->m_tree;
-	      gcc_assert (dst_rep);
-	      if (dst_pv->m_stack_depth
-		  >= src_state.m_region_model->get_stack_depth ())
-		continue;
-	      tentative_region_model_context ctxt;
-	      svalue_id src_sid
-		= src_state.m_region_model->get_rvalue (*dst_pv, &ctxt);
-	      if (src_sid.null_p () || ctxt.had_errors_p ())
-		continue;
-	      state_machine::state_t src_sm_val = src_smap.get_state (src_sid);
-	      if (dst_sm_val != src_sm_val)
-		{
-		  svalue_id dst_origin_sid = (*iter).second.m_origin;
-		  if (visitor->on_state_change (sm, src_sm_val, dst_sm_val,
-						dst_rep, dst_origin_sid))
-		    return true;
-		}
-	    }
-	}
-    }
-  return false;
-}
-
 /* Subclass of state_change_visitor that creates state_change_event
    instances.  */
 
@@ -1165,18 +994,9 @@ diagnostic_manager::add_events_for_eedge (const path_builder &pb,
       | ~~~~~~~~~~~~~^~~~~
       |              |
       |              (3) ...to here        (end_cfg_edge_event).  */
-  if (src_state.m_region_model)
-    {
-      state_change_event_creator visitor (eedge, emission_path);
-      for_each_state_change (src_state, dst_state, pb.get_ext_state (),
-			     &visitor);
-    }
-  if (src_state.m_region_model2)
-    {
-      state_change_event_creator2 visitor2 (eedge, emission_path);
-      for_each_state_change2 (src_state, dst_state, pb.get_ext_state (),
-			      &visitor2);
-    }
+  state_change_event_creator2 visitor2 (eedge, emission_path);
+  for_each_state_change2 (src_state, dst_state, pb.get_ext_state (),
+			  &visitor2);
 
   /* Allow non-standard edges to add events, e.g. when rewinding from
      longjmp to a setjmp.  */
@@ -1439,10 +1259,7 @@ diagnostic_manager::prune_path (checker_path *path,
 {
   LOG_FUNC (get_logger ());
   path->maybe_log (get_logger (), "path");
-  if (get_engine2 ())
-    prune_for_sm_diagnostic2 (path, sm, sval, state);
-  else
-    prune_for_sm_diagnostic (path, sm, var, state);
+  prune_for_sm_diagnostic2 (path, sm, sval, state);
   prune_interproc_events (path);
   finish_pruning (path);
   path->maybe_log (get_logger (), "pruned");
@@ -1467,282 +1284,6 @@ can_be_expr_of_interest_p (tree expr)
   return true;
 }
 
-// FIXME: old implementation:
-/* First pass of diagnostic_manager::prune_path: apply verbosity level,
-   pruning unrelated state change events.
-
-   Iterate backwards through PATH, skipping state change events that aren't
-   VAR but update the pertinent VAR when state-copying occurs.
-
-   As well as deleting events, call record_critical_state on events in
-   which state critical to the pending_diagnostic is being handled, so
-   that the event's get_desc vfunc can potentially supply a more precise
-   description of the event to the user.
-   e.g. improving
-     "calling 'foo' from 'bar'"
-   to
-     "passing possibly-NULL pointer 'ptr' to 'foo' from 'bar' as param 1"
-   when the diagnostic relates to later dereferencing 'ptr'.  */
-
-void
-diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
-					     const state_machine *sm,
-					     tree var,
-					     state_machine::state_t state) const
-{
-  update_for_unsuitable_sm_exprs (&var);
-
-  int idx = path->num_events () - 1;
-  while (idx >= 0 && idx < (signed)path->num_events ())
-    {
-      checker_event *base_event = path->get_checker_event (idx);
-      if (get_logger ())
-	{
-	  if (sm)
-	    {
-	      if (var)
-		log ("considering event %i, with var: %qE, state: %qs",
-		     idx, var, sm->get_state_name (state));
-	      else
-		log ("considering event %i, with global state: %qs",
-		     idx, sm->get_state_name (state));
-	    }
-	  else
-	    log ("considering event %i", idx);
-	}
-      gcc_assert (var == NULL || can_be_expr_of_interest_p (var));
-      switch (base_event->m_kind)
-	{
-	default:
-	  gcc_unreachable ();
-
-	case EK_DEBUG:
-	  if (m_verbosity < 4)
-	    {
-	      log ("filtering event %i: debug event", idx);
-	      path->delete_event (idx);
-	    }
-	  break;
-
-	case EK_CUSTOM:
-	  /* Don't filter custom events.  */
-	  break;
-
-	case EK_STMT:
-	  {
-	    /* If this stmt is the origin of "var", update var.  */
-	    if (var)
-	      {
-		statement_event *stmt_event = (statement_event *)base_event;
-		tree new_var = get_any_origin (stmt_event->m_stmt, var,
-					       stmt_event->m_dst_state);
-		if (new_var)
-		  {
-		    log ("event %i: switching var of interest from %qE to %qE",
-			 idx, var, new_var);
-		    var = new_var;
-		  }
-	      }
-	    if (m_verbosity < 4)
-	      {
-		log ("filtering event %i: statement event", idx);
-		path->delete_event (idx);
-	      }
-	  }
-	  break;
-
-	case EK_FUNCTION_ENTRY:
-	  if (m_verbosity < 1)
-	    {
-	      log ("filtering event %i: function entry", idx);
-	      path->delete_event (idx);
-	    }
-	  break;
-
-	case EK_STATE_CHANGE:
-	  {
-	    state_change_event *state_change = (state_change_event *)base_event;
-	    bool same_region = false;
-	    bool ctxt_had_errors = false;
-	    if (state_change->m_dst_state.m_region_model2)
-	      {
-		/* Use regions to compare var with the state_change's m_var,
-		   bulletproofing against cases where they can't have lvalues by
-		   using tentative_region_model_context.  */
-		tentative_region_model2_context ctxt;
-		const region2 *state_var_reg
-		  = state_change->get_lvalue2 (state_change->m_var, &ctxt);
-		const region2 *var_reg = state_change->get_lvalue2 (var, &ctxt);
-		ctxt_had_errors = ctxt.had_errors_p ();
-		same_region = (state_var_reg == var_reg && !ctxt.had_errors_p ());
-	      }
-	    else
-	      {
-		/* Use region IDs to compare var with the state_change's m_var,
-		   bulletproofing against cases where they can't have lvalues by
-		   using tentative_region_model_context.  */
-		tentative_region_model_context ctxt;
-		region_id state_var_rid
-		  = state_change->get_lvalue (state_change->m_var, &ctxt);
-		region_id var_rid = state_change->get_lvalue (var, &ctxt);
-		ctxt_had_errors = ctxt.had_errors_p ();
-		same_region = (state_var_rid == var_rid && !ctxt.had_errors_p ());
-	      }
-	    if (same_region)
-	      {
-		if (state_change->m_origin)
-		  {
-		    log ("event %i: switching var of interest from %qE to %qE",
-			 idx, var, state_change->m_origin);
-		    var = state_change->m_origin;
-		    update_for_unsuitable_sm_exprs (&var);
-		  }
-		log ("event %i: switching state of interest from %qs to %qs",
-		     idx, sm->get_state_name (state_change->m_to),
-		     sm->get_state_name (state_change->m_from));
-		state = state_change->m_from;
-	      }
-	    else if (m_verbosity < 4)
-	      {
-		if (var && state_change->m_var)
-		  log ("filtering event %i:"
-		       " state change to %qE unrelated to %qE",
-		       idx, state_change->m_var, var);
-		else if (state_change->m_var)
-		  log ("filtering event %i: state change to %qE",
-		       idx, state_change->m_var);
-		else
-		  log ("filtering event %i: global state change", idx);
-		if (ctxt_had_errors)
-		  log ("context had errors");
-		path->delete_event (idx);
-	      }
-	  }
-	  break;
-
-	case EK_STATE_CHANGE2:
-	  /* Old implementation should create EK_STATE_CHANGE instead.  */
-	  gcc_unreachable ();
-
-	case EK_START_CFG_EDGE:
-	  {
-	    cfg_edge_event *event = (cfg_edge_event *)base_event;
-	    const cfg_superedge& cfg_superedge
-	      = event->get_cfg_superedge ();
-	    const supernode *dest = event->m_sedge->m_dest;
-	    /* Do we have an SSA_NAME defined via a phi node in
-	       the dest CFG node?  */
-	    if (var && TREE_CODE (var) == SSA_NAME)
-	      if (SSA_NAME_DEF_STMT (var)->bb == dest->m_bb)
-		{
-		  if (gphi *phi
-		      = dyn_cast <gphi *> (SSA_NAME_DEF_STMT (var)))
-		    {
-		      /* Update var based on its phi node.  */
-		      tree old_var = var;
-		      var = cfg_superedge.get_phi_arg (phi);
-		      log ("updating from %qE to %qE based on phi node",
-			   old_var, var);
-		      if (get_logger ())
-			{
-			  pretty_printer pp;
-			  pp_gimple_stmt_1 (&pp, phi, 0, (dump_flags_t)0);
-			  log ("  phi: %s", pp_formatted_text (&pp));
-			}
-		      /* If we've chosen a bad exploded_path, then the
-			 phi arg might be a constant.  Fail gracefully for
-			 this case.  */
-		      update_for_unsuitable_sm_exprs (&var);
-		    }
-		}
-
-	    /* TODO: is this edge significant to var?
-	       See if var can be in other states in the dest, but not
-	       in other states in the src?
-	       Must have multiple sibling edges.  */
-
-	    if (event->should_filter_p (m_verbosity))
-	      {
-		log ("filtering events %i and %i: CFG edge", idx, idx + 1);
-		path->delete_event (idx);
-		/* Also delete the corresponding EK_END_CFG_EDGE.  */
-		gcc_assert (path->get_checker_event (idx)->m_kind
-			    == EK_END_CFG_EDGE);
-		path->delete_event (idx);
-	      }
-	  }
-	  break;
-
-	case EK_END_CFG_EDGE:
-	  /* These come in pairs with EK_START_CFG_EDGE events and are
-	     filtered when their start event is filtered.  */
-	  break;
-
-	case EK_CALL_EDGE:
-	  {
-	    call_event *event = (call_event *)base_event;
-	    const callgraph_superedge& cg_superedge
-	      = event->get_callgraph_superedge ();
-	    callsite_expr expr;
-	    tree caller_var
-	      = cg_superedge.map_expr_from_callee_to_caller (var, &expr);
-	    if (caller_var)
-	      {
-		log ("event %i:"
-		     " switching var of interest"
-		     " from %qE in callee to %qE in caller",
-		     idx, var, caller_var);
-		var = caller_var;
-		if (expr.param_p ())
-		  event->record_critical_state (var, state);
-		update_for_unsuitable_sm_exprs (&var);
-	      }
-	  }
-	  break;
-
-	case EK_RETURN_EDGE:
-	  // TODO: potentially update var/state based on return value,
-	  // args etc
-	  {
-	    if (var)
-	      {
-		return_event *event = (return_event *)base_event;
-		const callgraph_superedge& cg_superedge
-		  = event->get_callgraph_superedge ();
-		callsite_expr expr;
-		tree callee_var
-		  = cg_superedge.map_expr_from_caller_to_callee (var, &expr);
-		if (callee_var)
-		  {
-		    log ("event %i:"
-			 " switching var of interest"
-			 " from %qE in caller to %qE in callee",
-			 idx, var, callee_var);
-		    var = callee_var;
-		    if (expr.return_value_p ())
-		      event->record_critical_state (var, state);
-		    update_for_unsuitable_sm_exprs (&var);
-		  }
-	      }
-	  }
-	  break;
-
-	case EK_SETJMP:
-	  /* TODO: only show setjmp_events that matter i.e. those for which
-	     there is a later rewind event using them.  */
-	case EK_REWIND_FROM_LONGJMP:
-	case EK_REWIND_TO_SETJMP:
-	  break;
-
-	case EK_WARNING:
-	  /* Always show the final "warning" event in the path.  */
-	  break;
-	}
-      idx--;
-    }
-}
-
-// FIXME: new implementation:
 /* First pass of diagnostic_manager::prune_path: apply verbosity level,
    pruning unrelated state change events.
 
